osl::eval::ml::Promotion37 Class Reference

`#include <minorPiece.h>`

## Public Types

enum | { ONE_DIM = PTYPE_SIZE , DIM = ONE_DIM*EvalStages }

## Public Member Functions

template<osl::Player P>
osl::MultiInt | evalOne (const NumEffectState &state, int rank)
template<osl::Player P>
osl::MultiInt | evalWithUpdate (const NumEffectState &state, Move moved, MultiInt const &last_value)

## Static Public Member Functions

static void | setUp (const Weights &weights)
static MultiInt | eval (const NumEffectState &state)
template<Player P>
static MultiInt | evalOne (const NumEffectState &state, int rank)
template<Player P>
static MultiInt | evalWithUpdate (const NumEffectState &, Move moved, MultiInt const &last_value)

## Static Public Attributes

static CArray< MultiInt, ONE_DIM > | table

## Detailed Description

Definition at line 1723 of file minorPiece.h.

## Member Enumeration Documentation

## anonymous enum

anonymous enum

Enumerator
ONE_DIM |
DIM |

Definition at line 1726 of file minorPiece.h.

## Member Function Documentation

## eval()

osl::MultiInt osl::eval::ml::Promotion37::eval | ( | const NumEffectState & | state | ) |

static

Definition at line 3024 of file minorPiece.cc.

References evalOne().

Referenced by evalWithUpdate(), osl::eval::ml::OpenMidEndingEval::OpenMidEndingEval(), and osl::eval::ml::OpenMidEndingEval::updateSub().

## evalOne() [1/2]

template<osl::Player P>

osl::MultiInt osl::eval::ml::Promotion37::evalOne | ( | const NumEffectState & | state,
|  | int | rank )

Definition at line 2996 of file minorPiece.cc.

References osl::alt(), osl::NumEffectState::countEffect(), osl::NumEffectState::findCheapAttack(), osl::AdditionalEffect::hasEffect(), osl::isPiece(), osl::isPromoted(), osl::Piece::ptype(), osl::PTYPE_BASIC_MIN, osl::PTYPE_MAX, osl::sign(), and table.

## evalOne() [2/2]

template<Player P>

MultiInt osl::eval::ml::Promotion37::evalOne | ( | const NumEffectState & | state,
|  | int | rank )

static

Referenced by eval().

## evalWithUpdate() [1/2]

template<Player P>

MultiInt osl::eval::ml::Promotion37::evalWithUpdate | ( | const NumEffectState & | ,
|  | Move | moved,
|  | MultiInt const & | last_value )

static

## evalWithUpdate() [2/2]

template<osl::Player P>

osl::MultiInt osl::eval::ml::Promotion37::evalWithUpdate | ( | const NumEffectState & | state,
|  | Move | moved,
|  | MultiInt const & | last_value )

Definition at line 3031 of file minorPiece.cc.

References eval(), and osl::Move::isPass().

## setUp()

void osl::eval::ml::Promotion37::setUp | ( | const Weights & | weights | ) |

static

Definition at line 2986 of file minorPiece.cc.

References osl::NStages, ONE_DIM, table, and osl::eval::ml::Weights::value().

## Member Data Documentation

## table

osl::CArray< osl::MultiInt, osl::PTYPE_SIZE > osl::eval::ml::Promotion37::table

static

Definition at line 1735 of file minorPiece.h.

Referenced by evalOne(), and setUp().

The documentation for this class was generated from the following files:

- minorPiece.h
- minorPiece.cc